function [c] = chain21(l1,l2)
%computes derivatives of g(f(w,p)) at a point given the derivatives of f
%(->l1{:,:})
%and g (->l2{:})
order=size(l2,1);
%dimensionen bestimmen
l11=size(l1{1,1});
rank_sum=length(l11)-1;


l21=size(l1{2,1});
l12=size(l1{1,2});
dim=[length(l21) length(l12)]-rank_sum-1;
if l11(2)==1
    rank_sum=0;
end
    %rank of im(g)+1
    s=size(l2{1});
    dimg=length(s);
    if s(2)==1 && rank_sum>0
        dimg=1;
    end
    
gf=@(dn2,dn1) g_and_f(l1,l2,dn1+1,dn2+1,rank_sum,dim,dimg);

c{1,1}=gf(0,[]);
c{2,1}=gf(1,[1;0]);
c{1,2}=gf(1,[0;1]);
if order>2
    c{3,1}=gf(1,[2;0])+gf(2,[1 1;0 0]);
    c{2,2}=gf(1,[1;1])+gf(2,[1 0;0 1]);
    c{1,3}=gf(1,[0;2])+gf(2,[0 0;1 1]);
end
if order>3
    c{4,1}=gf(1,[3;0])+2*gf(2,[2 1;0 0])+gf(3,[1 1 1;0 0 0]);
    c{3,2}=gf(1,[2;1])+gf(2,[2 0;0 1])+gf(2,[1 1;0 1])+gf(2,[1 1;1 0])+gf(3,[1 1 0;0 0 1]);
    c{2,3}=gf(1,[1;2])+gf(2,[1 0;0 2])+gf(2,[1 0;1 1])+gf(2,[0 1;1 1])+gf(3,[1 0 0;0 1 1]);
    c{1,4}=gf(1,[0;3])+gf(2,[0 0;2 1])+gf(2,[0 0;1 2])+gf(3,[0 0 0;1 1 1]);
end

end


function [res]=g_and_f(l1,l2,dn1,dn2,rank_sum,dim,dimg)

res=l2{dn2};
    for i=1:dn2-1

        len1=length(size(res));
        len2=length(size(l1{dn1(1,i),dn1(2,i)}));
        if rank_sum>0 %if summation is necessary
            v1=[1:max(1,dimg) -1:-1:-rank_sum max(2,dimg+1):len1-rank_sum];%[1:max(2,dimg)-1 -1:-1:-rank_sum max(2,dimg):len1-rank_sum];
            v2=[1 -1:-1:-rank_sum len1-rank_sum+1:len1+len2-2*rank_sum-1];
        else
            v1=1:len1;
            v2=[1 2 len1+1:len1+len2-2];
        end
        res=tprod(res,v1,l1{dn1(1,i),dn1(2,i)},v2);
    end
       
 pe=1:dimg;
 j=dimg+1;

for i=1:dn2-1
    if dn1(1,i)>1
        t=dim(1)*(dn1(1,i)-1);
        pe(end+1:end+t)=j:j+t-1;
        j=j+t;
    end
    j=j+dim(2)*(dn1(2,i)-1);
end

pe=reorder(pe,max(2,j-1));
res=permute(res,pe);


end


function [t] = reorder(s,n)
    %e.g. ([2,4],5) |--> (2,4,1,3,5) 
    m=length(s);
    t=1:n;
        for i=1:m
          j=i;
          temp1=s(i);
         while t(j)~=s(i)
           temp2=t(j);
           t(j)=temp1;
           temp1=temp2;
           j=j+1;
         end
         t(j)=temp1;
        end
end