function [Q] = vectqr(A)
%Input is nx3 Matrix A
%each row vector should be normalized
%Computed is an orthonormal basis for each orthogonal
%comploment of each 3dim-row-vecor of A
%Output is nx3x2 array
n=size(A,1);
%Qf: ein orthonormaler vector fuer jede row von A
Qf=zeros(n,3);
Q1=Qf;
Q1(:,2)=A(:,3);
Q1(:,3)=-A(:,2);
Q2=Qf;
Q2(:,1)=A(:,3);
Q2(:,3)=-A(:,1);

%in a normalized 3-dim vecor the absolute value of at
%least on entry is larger or equal to 1/sqrt(3)>0.5
q1_gr0=(max(abs(Q1),[],2)>.5);
Qf=(q1_gr0*[1 1 1]).*Q1+((1-q1_gr0)*[1 1 1]).*Q2;

nor=sqrt(sum(Qf.^2,2));
%normalisieren
Qf=Qf./(nor*[1 1 1]);

Q=zeros(n,3,2);
Q(:,:,1)=Qf;
%vector product zum bestimmen des 2. orthonormalen vectors
Q(:,1,2)=A(:,2).*Qf(:,3)-A(:,3).*Qf(:,2);
Q(:,2,2)=A(:,3).*Qf(:,1)-A(:,1).*Qf(:,3);
Q(:,3,2)=A(:,1).*Qf(:,2)-A(:,2).*Qf(:,1);

end