function [grad,Hess] = harmgh(c)
%Gradient and Hessian of the harmonic energy of
%an elastic string

%extended c,i.e. with boundary points
cex=[[1;0;0] c [0;1;0]];
n=size(c,2)+1;
l=sphere_dist_der(cex(:,1:end-1)',cex(:,2:end)');
grad=zeros(3*(n-1),1);
Hess=sparse(3*(n-1),3*(n-1));

for i=1:n-1
   ind=3*(i-1)+1:3*i;
   grad(ind)=l{1,2}(i,:)+l{2,1}(i+1,:);
   Hess(ind,ind)=l{1,3}(i,:,:)+l{3,1}(i+1,:,:);
end
temp=zeros(3);
for i=2:n-1
    ind1=3*(i-2)+1:3*(i-1);
    ind2=ind1+3;
    temp(:,:)=l{2,2}(i,:,:);
    Hess(ind1,ind2)=temp;
    Hess(ind2,ind1)=temp'; 
end
grad=n*grad;
Hess=n*Hess;
end

